<!DOCTYPE html>
<html>
  <head>
    <meta content="text/html;charset=utf-8" http-equiv="Content-Type">
    <meta content="utf-8" http-equiv="encoding">
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="css/bootstrap.min.css">
    <link rel="stylesheet" href="css/bootstrap-select.min.css">
    <script src="./js/jquery-3.4.1.min.js"></script>
    <script src="./js/popper.min.js"></script>
    <script src="./js/bootstrap.min.js"></script>
    <script src="./js/bootstrap-select.min.js"></script>
    <script src="./js/ElGrapho.js"></script>

    <style>
      html, body {
        background-color: #000000;
        overflow: hidden;
      }

      a {
        color: #4b24bf;
      }

      .form-control {
        background-color: #000000;
      }

      input[type="text"]:focus {
        background-color: #000000;
        color:  #ffffff;
        border-color: rgba(102,70,190, 0.8);
        box-shadow: 0 1px 1px rgba(0, 0, 0, 0.075) inset, 0 0 8px rgba(102,70,190, 0.8);
        outline: 0 none;
      }

      input[type="search"]:focus {
        background-color: #000000;
        color:  #ffffff;
        border-color: rgba(102,70,190, 0.8);
        box-shadow: 0 1px 1px rgba(0, 0, 0, 0.075) inset, 0 0 8px rgba(102,70,190, 0.8);
        outline: 0 none;
      }

      .no-results {
        background-color: #343a40;
      }

      .list-group-dark .list-group-item {
        background-color: #343a40;
        border: 1px solid #000000;
        word-break: break-all;
      }

      .list-group-item p {
        margin-bottom: 0;
      }

      .neighbor{
        width: 270px!important;
        margin-left: 10px;
      }

      .list-group-dark .list-group-item:hover {
        background-color: #263132;
      }

      .dropdown-menu {
        background-color: #343a40;
        color: #ffffff;
      }

      .dropdown-item {
        color: #ffffff;
      }

      .dropdown-item .dropdown-item:hover {
        background-color: #263132;
      }

      .dropdown-item.active, .dropdown-item:active {
        background-color: #4b24bf;
      }

      .el-grapho-tooltip {
        background-color: #343a40;
        border: 1px solid #000000;
        color: #bbbbbb;
        word-break: break-all;
      }

      #sidebar {
        width: 300px;
        -ms-flex: 0 0 290px;
        flex: 0 0 290px;
        border-left: 1px #333;
        overflow-y: scroll;
        -ms-overflow-style: none;
        scrollbar-width: none;
        height:90vh;
      }

      #sidebar::-webkit-scrollbar {
        display: none;
      }

      #node_details {
        width: 280px;
        color: #bbbbbb;
      }

      #search_results {
        width: 280px;
        color: #bbbbbb;
      }
    </style>
    <script>

    window.onload = function() {
      make_graph()

      $('#graph_selector').on('changed.bs.select',
        function (e, clickedIndex, isSelected, previousValue) {
          make_graph()
      });

      document.getElementById('search_field')
        .addEventListener("keyup", function(event) {
        event.preventDefault();
        if (event.keyCode === 13) {
            search()
        }
      });
      $('#search_field').tooltip()

      document.getElementById('graph_container')
        .addEventListener("wheel", function(event) {
        event.preventDefault();
        let zoomfactor = Math.max(1 + Math.min(event.deltaY * -0.01, 1.2), .8);
        //let zoomfactor = event.deltaY > 0 ? 0.75 : 1.25
        if(graph.zoomX <= 1) {
          if(zoomfactor > 1)
            graph.zoomToPoint(0,0,zoomfactor,zoomfactor)
        } else if(graph.zoomX>4) {
          if(zoomfactor < 1)
            graph.zoomToPoint(0,0,zoomfactor,zoomfactor)
        //} else if(graph.zoomX * zoomfactor < 1) {
        } else {
          graph.zoomToPoint(0,0,zoomfactor,zoomfactor)
        }
      });
    };

    window.onresize = function() {
      graph.setSize(window.innerWidth-320, window.innerHeight-120)
    }

    </script>
    <script>

      function make_graph() {
        var node_size = window.devicePixelRatio * 0.2
        var edge_size = window.devicePixelRatio * 0.15

        var search_result_container = document.getElementById('search_results');
        search_result_container.innerHTML = '';

        var node_details = document.getElementById('node_details');
        node_details.innerHTML = '';

        var graph_file = document.getElementsByClassName('filter-option-inner-inner')[0].textContent
        if(graph_file == "all groups") {
          graph_file = "all.json"
        } else if(graph_file == "no group")
          graph_file = "None.json"
        else {
          graph_file = graph_file.replace(" ","_") + ".json"
          node_size = window.devicePixelRatio * 0.4
        }
        fetch('./graphs/' + graph_file)
          .then(response => response.json())
          .then( function(data){

            window.model = data;
            window.model["steps"] = 20
            if (typeof window.graph !== "undefined") {
               window.graph.destroy();
            }
            window.graph = new ElGrapho({
              container: document.getElementById('graph_container'),
              model: ElGrapho.layouts.ForceDirected(window.model),
              width: window.innerWidth-320,
              height: window.innerHeight-120,
              nodeOutline: false,
              darkMode: true,
              glowBlend: 0.9,
              nodeSize: node_size,
              edgeSize: edge_size,
              animations: true,
              showLoading: true
            });

            graph.tooltipTemplate = function(index, el) {
              el.innerHTML = graph.model.nodes[index]["name"] + "<br/>";
              var color = get_color(graph.model.nodes[index]["group"])
              var group_label = ""
              if(graph.model.nodes[index]["group_label"] !== "None") {
                group_label = "group::" + graph.model.nodes[index]["group_label"]
              }
              el.innerHTML += "<span class='badge badge-pill' style='color:" +color[1]+ "; background-color:"+color[0]+"'>" + group_label + "</span>"
            };

            graph.on('node-click', function(evt) {
              show_node_details(evt.dataIndex)
            });
          });
      }

      function get_color(group_id) {
        var validColor = group_id % 10;
        if (validColor == 0) {
          return ["rgb(125, 0, 67)","#FFFFFF"];
        }
        else if (validColor == 1) {
          return ["rgb(158, 0, 124)","#FFFFFF"];
        }
        else if (validColor == 2) {
          return ["rgb(186, 0, 190)","#FFFFFF"];
        }
        else if (validColor == 3) {
          return ["rgb(166, 0, 221)","#FFFFFF"];
        }
        else if (validColor == 4) {
          return ["rgb(125, 0, 251)","#FFFFFF"];
        }
        else if (validColor == 5) {
          return ["rgb(255, 173, 20)","#000000"];
        }
        else if (validColor == 6) {
          return ["rgb(255, 40, 40)","#FFFFFF"];
        }
        else if (validColor == 7) {
          return ["rgb(255, 60, 76)","#000000"];
        }
        else if (validColor == 8) {
          return ["rgb(255, 124, 80)","#000000"];
        }
        else if (validColor == 9) {
          return ["rgb(255, 227, 100)","#000000"];
        }
      }


      function show_node_details(node_id){
        var search_result_container = document.getElementById('search_results');
        var node_details = document.getElementById('node_details');

        node_details.innerHTML = 'Node details:';
        make_search_result_entry(node_id, node_details)
        var neighbortext = document.createElement('a');
        neighbortext.setAttribute('href', "#collapseResult");
        neighbortext.setAttribute('data-toggle', "collapse");
        neighbortext.setAttribute('data-target', "#neighbor_nodes");
        neighbortext.setAttribute('aria-expanded', "true");
        neighbortext.setAttribute('aria-controls', "neighbor_nodes");
        neighbortext.setAttribute('style', "color: #bbbbbb; text-decoration: underline;");
        neighbortext.appendChild(document.createTextNode("Links (" + graph.model.nodes[node_id]["neighbor_nodes"].length + "):"));
        node_details.appendChild(neighbortext);
        var neighbor_nodes = document.createElement('div');
        neighbor_nodes.setAttribute('id', "neighbor_nodes");
        neighbor_nodes.setAttribute('class', "collapse show");
        node_details.appendChild(neighbor_nodes);
        for(let neighbor_id of graph.model.nodes[node_id]["neighbor_nodes"].values()){
          make_search_result_entry(neighbor_id, neighbor_nodes, true)
        }
      }

      function make_search_result_entry(node_id, result_list, neighbor=false) {
        result = graph.model.nodes[node_id]
        var result_element = document.createElement('a');
        var class_attributes = 'list-group-item list-group-item-action'
        if(neighbor) {
          class_attributes += " neighbor"
        }
        var current_selection = graph.selectedIndex
        result_element.setAttribute('class', class_attributes);
        result_element.setAttribute('id', 'node_details_'+node_id);
        result_element.setAttribute('onclick', "highlight_node("+result["elgrapho_id"]+")")
        result_element.setAttribute('onmouseover', "current_selection = graph.selectedIndex; graph.selectNode("+result["elgrapho_id"]+")")
        result_element.setAttribute('onmouseout', "graph.selectNode(current_selection)")
        var result_title = document.createElement('p');
        result_title.setAttribute('class', 'font-weight-bold');
        
        result_title.appendChild(document.createTextNode(result["name"]));
        result_element.appendChild(result_title);
        var result_link = document.createElement('a');
        result_link.setAttribute('href', result["url"]);
        result_link.setAttribute('target', "_blank");
        result_link.setAttribute('style', 'color:#999999; margin-left:5px');
        result_link.appendChild(document.createTextNode("(link)"));
        result_title.appendChild(result_link)
        //result_element.appendChild(document.createTextNode(result["name"]));
        if(result["group_label"] !== "None") {
          var result_group = document.createElement('span');
          result_group.setAttribute('class', 'badge badge-pill');
          var color = get_color(result["group"])
          result_group.setAttribute('style', 'color:' +color[1]+ '; background-color:'+color[0]);
          result_group.appendChild(document.createTextNode(" group::" + result["group_label"]));
          result_element.appendChild(result_group)
        }
        result_list.appendChild(result_element);
      }

      function search(){
        results = []
        var search_term = document.getElementById('search_field').value.toLowerCase()
        for (node in graph.model.nodes) {
          node = graph.model.nodes[node]
          if(search_term.startsWith("group::")) {
            group_search = search_term.substring(search_term.lastIndexOf(":")+1)
            if(node["group_label"].toLowerCase().includes(group_search.toLowerCase())) {
              results.push(node["elgrapho_id"])
            }
          } else if(search_term.match(/#[1-9][0-9]*/g)) {
            if(node["id"] == search_term.substring(1)) {
              results.push(node["elgrapho_id"])
            }
          } else {
            if(node["name"].toLowerCase().includes(search_term.toLowerCase())) {
              results.push(node["elgrapho_id"])
            }
          }
        }
        var search_result_container = document.getElementById('search_results');
        search_result_container.innerHTML = '';
        var result_list = document.createElement('div');
        result_list.setAttribute('id', 'result_list');
        result_list.setAttribute('class', 'list-group list-group-dark');
        var result_count = 0
        for (result in results) {
          result_count ++
          make_search_result_entry(results[result],result_list)
        }
        search_result_container.appendChild(document.createTextNode("Search results (" + result_count + "):"));
        search_result_container.appendChild(result_list)
      }


      function wait_for_graph() {
        return new Promise((resolve) => {
        const interval = setInterval(()=> {
          if(graph == null || (graph.animations.length < 1 && !graph.dirty)){
            clearInterval(interval)
            resolve(true)
          }
        }, 50)

        })
      }

      async function highlight_node(node) {
        show_node_details(node)
        graph.reset();
        await wait_for_graph();
        graph.selectNode(node)
        graph.selectGroup(graph.model.nodes[node]["group"])
        await wait_for_graph();
        graph.zoomToPoint((graph.model.nodes[node].x * graph.viewport.width/2)*-1,(graph.model.nodes[node].y * graph.viewport.height/2)*-1,1,1);
        await wait_for_graph();
        graph.zoomIn(4,4)
      }
    </script>
  </head>
  <body>
    <div class="row">
      <div class="col">
        <div id="heading" class="container-fluid text-white" style="background-color: #000000">
          <h4 style="color: #FFFFFF;"><img style="height: 58px" src="assets/gitlab-logo-white-rgb.svg"/><a style="color: #fff" href="https://gitlab.com/gitlab-com/cs-tools/gitlab-cs-tools/issue-graph">issue graph</a>
          </h4>
        </div>
      </div>
      <div class="col col-lg-1">
        <div class="input-group float-right mt-2 mr-2">
          <select class="selectpicker" id="graph_selector" data-live-search="true" data-style="btn-dark">
            <optgroup>
              <option>all groups</option>
              <option>no group</option>
            </optgroup>
            <optgroup>
              <option>access</option>
              <option>activation</option>
              <option>adoption</option>
              <option>analyzer frontend</option>
              <option>applied ml</option>
              <option>certify</option>
              <option>code review</option>
              <option>compliance</option>
              <option>composition analysis</option>
              <option>configure</option>
              <option>container security</option>
              <option>conversion</option>
              <option>database</option>
              <option>distribution</option>
              <option>dynamic analysis</option>
              <option>editor</option>
              <option>expansion</option>
              <option>foundations</option>
              <option>geo</option>
              <option>gitaly</option>
              <option>global search</option>
              <option>group templates</option>
              <option>import</option>
              <option>incubation</option>
              <option>integrations</option>
              <option>license</option>
              <option>machine learning</option>
              <option>memory</option>
              <option>monitor</option>
              <option>not_owned</option>
              <option>optimize</option>
              <option>package</option>
              <option>pipeline authoring</option>
              <option>pipeline execution</option>
              <option>pricing</option>
              <option>product intelligence</option>
              <option>product planning</option>
              <option>project management</option>
              <option>purchase</option>
              <option>release</option>
              <option>runner</option>
              <option>scalability</option>
              <option>sharding</option>
              <option>source code</option>
              <option>static analysis</option>
              <option>testing</option>
              <option>threat insights</option>
              <option>utilization</option>
              <option>verify</option>
              <option>vulnerability research</option>
              <option>workspace</option>
            </optgroup>
          </select>
        </div>
      </div>
      <div  class="col col-lg-2">
        <div style="width: 265px;" class="input-group mt-2 float-right">
          <input type="text" class="form-control" data-toggle="tooltip" data-placement="bottom" title="search for title text, group:: or #issue_iid" placeholder="Search" aria-label="Search" id="search_field">
          <div class="input-group-append">
            <button class="btn btn-dark" type="button" id="search_button" onclick="search()">Search</button>
          </div>
        </div>
      </div>
    </div>
    <div class="container-fluid">
      <div class="row">
        <div class="col">
          <div id="graph_container">
        </div>
        </div>
        <div class="col" id="sidebar">
          <div class="row list-group list-group-dark" id="node_details">
          </div>
          <div class="row" id="search_results">
          </div>
         </div>
      </div>
      <div style="color: #bbbbbb; text-align: right; height: 20px" class="row">
        <div class="col">
        <p class="text-right"><a href="https://gitlab.com/gitlab-org/gitlab/-/issues/">gitlab-org/gitlab issues link graph</a> rendered using <a href="https://github.com/ericdrowell/ElGrapho">El Grapho </a> by <a href="https://gitlab.com/mbruemmer">@mbruemmer</a></p>
      </div>
      </div>
    </div>
  </body>
</html>